# coding: utf-8

"""
    Assetic Integration API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class AssetApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def asset_get(self, id, attributes, **kwargs):
        """
        Get complex asset by either its complex asset internal GUID or its own friendly complex asset id
        To get Attributes metadata, please refer to <pre>/api/v2/search/{id}/metadata</pre><br /><br />              Sample request: <br /><pre>               /api/v2/assets/ABAB              /api/v2/assets/ABAB?attributes=Comment,DimensionDetail,RaterComment              /api/v2/assets/495365a0-7e6a-e611-9469-06edd62954d7?attributes=Comment,DimensionDetail,RaterComment                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_get(id, attributes, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id:  (required)
        :param list[str] attributes: List of attributes required to be retrieved (required)
        :return: Assetic3IntegrationRepresentationsComplexAssetRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.asset_get_with_http_info(id, attributes, **kwargs)
        else:
            (data) = self.asset_get_with_http_info(id, attributes, **kwargs)
            return data

    def asset_get_with_http_info(self, id, attributes, **kwargs):
        """
        Get complex asset by either its complex asset internal GUID or its own friendly complex asset id
        To get Attributes metadata, please refer to <pre>/api/v2/search/{id}/metadata</pre><br /><br />              Sample request: <br /><pre>               /api/v2/assets/ABAB              /api/v2/assets/ABAB?attributes=Comment,DimensionDetail,RaterComment              /api/v2/assets/495365a0-7e6a-e611-9469-06edd62954d7?attributes=Comment,DimensionDetail,RaterComment                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_get_with_http_info(id, attributes, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id:  (required)
        :param list[str] attributes: List of attributes required to be retrieved (required)
        :return: Assetic3IntegrationRepresentationsComplexAssetRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'attributes']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method asset_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `asset_get`")
        # verify the required parameter 'attributes' is set
        if ('attributes' not in params) or (params['attributes'] is None):
            raise ValueError("Missing the required parameter `attributes` when calling `asset_get`")


        collection_formats = {}

        resource_path = '/api/v2/assets/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}
        if 'attributes' in params:
            query_params['attributes'] = params['attributes']
            collection_formats['attributes'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsComplexAssetRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def asset_get_0(self, attributes, **kwargs):
        """
        Get a collection of asset
        Supported filter operators: <br /><table><tr><td>=</td><td>is equal to</td></tr><tr><td>&gt;</td><td>is greater than</td></tr><tr><td>&gt;=</td><td>is greater than or equal to</td></tr><tr><td>&lt;</td><td>is less than</td></tr><tr><td>&lt;=</td><td>is less than or equal to</td></tr><tr><td>~eq~</td><td>is equal to</td></tr><tr><td>~neq~</td><td>is not equal to</td></tr><tr><td>~lt~</td><td>is less than</td></tr><tr><td>~lte~</td><td>is less than or equal to</td></tr><tr><td>~gt~</td><td>is greater than</td></tr><tr><td>~gte~</td><td>is greater than or equal to</td></tr><tr><td>~startswith~</td><td>starts with</td></tr><tr><td>~contains~</td><td>contains</td></tr><tr><td>~notsubstringof~</td><td>does not contain</td></tr><tr><td>~endswith~</td><td>ends with</td></tr><tr><td>~doesnotcontain~</td><td>contains</td></tr><tr><td>~or~</td><td>or</td></tr><tr><td>~and~</td><td>and</td></tr></table><br />               Supported sorting operators: <br /><table><tr><td>-asc</td><td>ascending</td></tr><tr><td>-desc</td><td>descending</td></tr></table><br />              To get Attributes metadata, please refer to <pre>/api/v2/search/{id}/metadata</pre><br /><br />              Sample request: <br /><pre>               /api/v2/assets/?requestParams.filters=AssetName~contains~'Alice'~or~AssetCategory='Artworks'              /api/v2/assets/?attributes=Comment,DimensionDetail,RaterComment              /api/v2/assets/?sorts=AssetName-asc,AssetId-asc              /api/v2/assets/?PageSize=20&amp;page=1              /api/v2/assets/?requestParams.filters=AssetName~contains~'Alice'~or~AssetCategory='Artworks'&amp;attributes=Comment,attributes=Comment,DimensionDetail,RaterComment                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_get_0(attributes, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param list[str] attributes:  (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsComplexAssetListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.asset_get_0_with_http_info(attributes, **kwargs)
        else:
            (data) = self.asset_get_0_with_http_info(attributes, **kwargs)
            return data

    def asset_get_0_with_http_info(self, attributes, **kwargs):
        """
        Get a collection of asset
        Supported filter operators: <br /><table><tr><td>=</td><td>is equal to</td></tr><tr><td>&gt;</td><td>is greater than</td></tr><tr><td>&gt;=</td><td>is greater than or equal to</td></tr><tr><td>&lt;</td><td>is less than</td></tr><tr><td>&lt;=</td><td>is less than or equal to</td></tr><tr><td>~eq~</td><td>is equal to</td></tr><tr><td>~neq~</td><td>is not equal to</td></tr><tr><td>~lt~</td><td>is less than</td></tr><tr><td>~lte~</td><td>is less than or equal to</td></tr><tr><td>~gt~</td><td>is greater than</td></tr><tr><td>~gte~</td><td>is greater than or equal to</td></tr><tr><td>~startswith~</td><td>starts with</td></tr><tr><td>~contains~</td><td>contains</td></tr><tr><td>~notsubstringof~</td><td>does not contain</td></tr><tr><td>~endswith~</td><td>ends with</td></tr><tr><td>~doesnotcontain~</td><td>contains</td></tr><tr><td>~or~</td><td>or</td></tr><tr><td>~and~</td><td>and</td></tr></table><br />               Supported sorting operators: <br /><table><tr><td>-asc</td><td>ascending</td></tr><tr><td>-desc</td><td>descending</td></tr></table><br />              To get Attributes metadata, please refer to <pre>/api/v2/search/{id}/metadata</pre><br /><br />              Sample request: <br /><pre>               /api/v2/assets/?requestParams.filters=AssetName~contains~'Alice'~or~AssetCategory='Artworks'              /api/v2/assets/?attributes=Comment,DimensionDetail,RaterComment              /api/v2/assets/?sorts=AssetName-asc,AssetId-asc              /api/v2/assets/?PageSize=20&amp;page=1              /api/v2/assets/?requestParams.filters=AssetName~contains~'Alice'~or~AssetCategory='Artworks'&amp;attributes=Comment,attributes=Comment,DimensionDetail,RaterComment                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_get_0_with_http_info(attributes, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param list[str] attributes:  (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsComplexAssetListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['attributes', 'request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method asset_get_0" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'attributes' is set
        if ('attributes' not in params) or (params['attributes'] is None):
            raise ValueError("Missing the required parameter `attributes` when calling `asset_get_0`")


        collection_formats = {}

        resource_path = '/api/v2/assets'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'attributes' in params:
            query_params['attributes'] = params['attributes']
            collection_formats['attributes'] = 'multi'
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsComplexAssetListRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def asset_post(self, complex_asset_representation, **kwargs):
        """
        Create an asset
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_post(complex_asset_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Assetic3IntegrationRepresentationsComplexAssetRepresentation complex_asset_representation:  (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.asset_post_with_http_info(complex_asset_representation, **kwargs)
        else:
            (data) = self.asset_post_with_http_info(complex_asset_representation, **kwargs)
            return data

    def asset_post_with_http_info(self, complex_asset_representation, **kwargs):
        """
        Create an asset
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_post_with_http_info(complex_asset_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Assetic3IntegrationRepresentationsComplexAssetRepresentation complex_asset_representation:  (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['complex_asset_representation']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method asset_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'complex_asset_representation' is set
        if ('complex_asset_representation' not in params) or (params['complex_asset_representation'] is None):
            raise ValueError("Missing the required parameter `complex_asset_representation` when calling `asset_post`")


        collection_formats = {}

        resource_path = '/api/v2/assets'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'complex_asset_representation' in params:
            body_params = params['complex_asset_representation']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def asset_put(self, id, complex_asset_representation, **kwargs):
        """
        Update an asset
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_put(id, complex_asset_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :param Assetic3IntegrationRepresentationsComplexAssetRepresentation complex_asset_representation:  (required)
        :return: Assetic3IntegrationRepresentationsComplexAssetRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.asset_put_with_http_info(id, complex_asset_representation, **kwargs)
        else:
            (data) = self.asset_put_with_http_info(id, complex_asset_representation, **kwargs)
            return data

    def asset_put_with_http_info(self, id, complex_asset_representation, **kwargs):
        """
        Update an asset
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_put_with_http_info(id, complex_asset_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :param Assetic3IntegrationRepresentationsComplexAssetRepresentation complex_asset_representation:  (required)
        :return: Assetic3IntegrationRepresentationsComplexAssetRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'complex_asset_representation']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method asset_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `asset_put`")
        # verify the required parameter 'complex_asset_representation' is set
        if ('complex_asset_representation' not in params) or (params['complex_asset_representation'] is None):
            raise ValueError("Missing the required parameter `complex_asset_representation` when calling `asset_put`")


        collection_formats = {}

        resource_path = '/api/v2/assets/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'complex_asset_representation' in params:
            body_params = params['complex_asset_representation']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsComplexAssetRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def asset_search_asset_spatial_locations(self, **kwargs):
        """
        Get Asset Spatial Locations
        Supported units:              <ul><li>km/kilometer(s)/kilometre(s)</li><li>m/meter(s)/metre(s)</li></ul><br />              Supported condition operators:              <table><tr><td>near_point</td><td>return all assets which locations are intersecting with given range</td></tr></table><br /><br /><br />              Sample request: <br /><br /><pre>               /api/v2/assets/locations/?requestParams.longitude=144.5437&amp;requestParams.latitude=-37.6691                  &amp;requestParams.condition=near_point                  &amp;requestParams.range=3400&amp;requestParams.unit=meter              </pre><pre>               /api/v2/assets/locations/?requestParams.longitude=115.0753&amp;requestParams.latitude=-33.9544                  &amp;requestParams.condition=near_point                  &amp;requestParams.range=3.5&amp;requestParams.unit=kilometer                  &amp;requestParams.page=2&amp;requestParams.pagesize=10              </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_search_asset_spatial_locations(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param float request_params_longitude:
        :param float request_params_latitude:
        :param str request_params_condition:
        :param float request_params_range:
        :param str request_params_unit:
        :param int request_params_page:
        :param int request_params_page_size:
        :return: Assetic3IntegrationRepresentationsGeoJsonRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.asset_search_asset_spatial_locations_with_http_info(**kwargs)
        else:
            (data) = self.asset_search_asset_spatial_locations_with_http_info(**kwargs)
            return data

    def asset_search_asset_spatial_locations_with_http_info(self, **kwargs):
        """
        Get Asset Spatial Locations
        Supported units:              <ul><li>km/kilometer(s)/kilometre(s)</li><li>m/meter(s)/metre(s)</li></ul><br />              Supported condition operators:              <table><tr><td>near_point</td><td>return all assets which locations are intersecting with given range</td></tr></table><br /><br /><br />              Sample request: <br /><br /><pre>               /api/v2/assets/locations/?requestParams.longitude=144.5437&amp;requestParams.latitude=-37.6691                  &amp;requestParams.condition=near_point                  &amp;requestParams.range=3400&amp;requestParams.unit=meter              </pre><pre>               /api/v2/assets/locations/?requestParams.longitude=115.0753&amp;requestParams.latitude=-33.9544                  &amp;requestParams.condition=near_point                  &amp;requestParams.range=3.5&amp;requestParams.unit=kilometer                  &amp;requestParams.page=2&amp;requestParams.pagesize=10              </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.asset_search_asset_spatial_locations_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param float request_params_longitude:
        :param float request_params_latitude:
        :param str request_params_condition:
        :param float request_params_range:
        :param str request_params_unit:
        :param int request_params_page:
        :param int request_params_page_size:
        :return: Assetic3IntegrationRepresentationsGeoJsonRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_params_longitude', 'request_params_latitude', 'request_params_condition', 'request_params_range', 'request_params_unit', 'request_params_page', 'request_params_page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method asset_search_asset_spatial_locations" % key
                )
            params[key] = val
        del params['kwargs']


        collection_formats = {}

        resource_path = '/api/v2/assets/locations'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'request_params_longitude' in params:
            query_params['requestParams.longitude'] = params['request_params_longitude']
        if 'request_params_latitude' in params:
            query_params['requestParams.latitude'] = params['request_params_latitude']
        if 'request_params_condition' in params:
            query_params['requestParams.condition'] = params['request_params_condition']
        if 'request_params_range' in params:
            query_params['requestParams.range'] = params['request_params_range']
        if 'request_params_unit' in params:
            query_params['requestParams.unit'] = params['request_params_unit']
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsGeoJsonRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
