# coding: utf-8

"""
    Assetic Integration API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class ComponentApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def component_get(self, id, **kwargs):
        """
        Get component by either component internal id (GUID) or its friendly id
        Sample requests: <br /><pre>               /api/v2/components/CP000ABAB              /api/v2/components/c1bf4b20-f3b1-e611-946c-06edd62954d7                   </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_get(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component Id (required)
        :return: Assetic3IntegrationRepresentationsComponentRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.component_get_with_http_info(id, **kwargs)
        else:
            (data) = self.component_get_with_http_info(id, **kwargs)
            return data

    def component_get_with_http_info(self, id, **kwargs):
        """
        Get component by either component internal id (GUID) or its friendly id
        Sample requests: <br /><pre>               /api/v2/components/CP000ABAB              /api/v2/components/c1bf4b20-f3b1-e611-946c-06edd62954d7                   </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_get_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component Id (required)
        :return: Assetic3IntegrationRepresentationsComponentRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method component_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `component_get`")


        collection_formats = {}

        resource_path = '/api/v2/components/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsComponentRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def component_get_0(self, **kwargs):
        """
        Get a collection of component
        Supported filter operators: <br /><table><tr><td>=</td><td>is equal to</td></tr><tr><td>&gt;</td><td>is greater than</td></tr><tr><td>&gt;=</td><td>is greater than or equal to</td></tr><tr><td>&lt;</td><td>is less than</td></tr><tr><td>&lt;=</td><td>is less than or equal to</td></tr><tr><td>~eq~</td><td>is equal to</td></tr><tr><td>~neq~</td><td>is not equal to</td></tr><tr><td>~lt~</td><td>is less than</td></tr><tr><td>~lte~</td><td>is less than or equal to</td></tr><tr><td>~gt~</td><td>is greater than</td></tr><tr><td>~gte~</td><td>is greater than or equal to</td></tr><tr><td>~startswith~</td><td>starts with</td></tr><tr><td>~contains~</td><td>contains</td></tr><tr><td>~notsubstringof~</td><td>does not contain</td></tr><tr><td>~endswith~</td><td>ends with</td></tr><tr><td>~doesnotcontain~</td><td>contains</td></tr><tr><td>~or~</td><td>or</td></tr><tr><td>~and~</td><td>and</td></tr></table><br />               Supported sorting operators: <br /><table><tr><td>-asc</td><td>ascending</td></tr><tr><td>-desc</td><td>descending</td></tr></table><br /><strong>Note:</strong><ul><li>Dimension Unit has to be in <strong>Singular form</strong>, such as Metre, Mile, Gallon (US), Kilovolt Ampere, Kilometre Per Hour, Celsius, etc..</li></ul>              Sample request: <br /><pre>               /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'              /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'~and~MaterialType~eq~'Brick Walls'              /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'~and~DesignLife&gt;='50'              /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'~or~DimensionUnit='Metre'              /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'&amp;sorts=Name-desc                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_get_0(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsComponentListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.component_get_0_with_http_info(**kwargs)
        else:
            (data) = self.component_get_0_with_http_info(**kwargs)
            return data

    def component_get_0_with_http_info(self, **kwargs):
        """
        Get a collection of component
        Supported filter operators: <br /><table><tr><td>=</td><td>is equal to</td></tr><tr><td>&gt;</td><td>is greater than</td></tr><tr><td>&gt;=</td><td>is greater than or equal to</td></tr><tr><td>&lt;</td><td>is less than</td></tr><tr><td>&lt;=</td><td>is less than or equal to</td></tr><tr><td>~eq~</td><td>is equal to</td></tr><tr><td>~neq~</td><td>is not equal to</td></tr><tr><td>~lt~</td><td>is less than</td></tr><tr><td>~lte~</td><td>is less than or equal to</td></tr><tr><td>~gt~</td><td>is greater than</td></tr><tr><td>~gte~</td><td>is greater than or equal to</td></tr><tr><td>~startswith~</td><td>starts with</td></tr><tr><td>~contains~</td><td>contains</td></tr><tr><td>~notsubstringof~</td><td>does not contain</td></tr><tr><td>~endswith~</td><td>ends with</td></tr><tr><td>~doesnotcontain~</td><td>contains</td></tr><tr><td>~or~</td><td>or</td></tr><tr><td>~and~</td><td>and</td></tr></table><br />               Supported sorting operators: <br /><table><tr><td>-asc</td><td>ascending</td></tr><tr><td>-desc</td><td>descending</td></tr></table><br /><strong>Note:</strong><ul><li>Dimension Unit has to be in <strong>Singular form</strong>, such as Metre, Mile, Gallon (US), Kilovolt Ampere, Kilometre Per Hour, Celsius, etc..</li></ul>              Sample request: <br /><pre>               /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'              /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'~and~MaterialType~eq~'Brick Walls'              /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'~and~DesignLife&gt;='50'              /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'~or~DimensionUnit='Metre'              /api/v2/components/?requestParams.filters=AssetId~contains~'ABAB'&amp;sorts=Name-desc                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_get_0_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsComponentListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method component_get_0" % key
                )
            params[key] = val
        del params['kwargs']


        collection_formats = {}

        resource_path = '/api/v2/components'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsComponentListRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def component_get_dimension(self, id, **kwargs):
        """
        Get dimension list of given component id
        Sample requests: <br /><pre>               /api/v2/components/CP00101011/dimensions              /api/v2/components/ad7dfac3-53ef-e611-8568-b0c090253c49/dimensions                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_get_dimension(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component Id (required)
        :return: Assetic3IntegrationRepresentationsComponentDimensionListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.component_get_dimension_with_http_info(id, **kwargs)
        else:
            (data) = self.component_get_dimension_with_http_info(id, **kwargs)
            return data

    def component_get_dimension_with_http_info(self, id, **kwargs):
        """
        Get dimension list of given component id
        Sample requests: <br /><pre>               /api/v2/components/CP00101011/dimensions              /api/v2/components/ad7dfac3-53ef-e611-8568-b0c090253c49/dimensions                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_get_dimension_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component Id (required)
        :return: Assetic3IntegrationRepresentationsComponentDimensionListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method component_get_dimension" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `component_get_dimension`")


        collection_formats = {}

        resource_path = '/api/v2/components/{id}/dimensions'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsComponentDimensionListRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def component_post(self, component_representation, **kwargs):
        """
        Create component
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_post(component_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Assetic3IntegrationRepresentationsComponentRepresentation component_representation: Component Representation (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.component_post_with_http_info(component_representation, **kwargs)
        else:
            (data) = self.component_post_with_http_info(component_representation, **kwargs)
            return data

    def component_post_with_http_info(self, component_representation, **kwargs):
        """
        Create component
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_post_with_http_info(component_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Assetic3IntegrationRepresentationsComponentRepresentation component_representation: Component Representation (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['component_representation']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method component_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'component_representation' is set
        if ('component_representation' not in params) or (params['component_representation'] is None):
            raise ValueError("Missing the required parameter `component_representation` when calling `component_post`")


        collection_formats = {}

        resource_path = '/api/v2/components'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'component_representation' in params:
            body_params = params['component_representation']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def component_post_dimension(self, id, component_dimension_representation, **kwargs):
        """
        Create dimension of given component id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_post_dimension(id, component_dimension_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component id (required)
        :param Assetic3IntegrationRepresentationsComponentDimensionRepresentation component_dimension_representation: Component Dimension Representation (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.component_post_dimension_with_http_info(id, component_dimension_representation, **kwargs)
        else:
            (data) = self.component_post_dimension_with_http_info(id, component_dimension_representation, **kwargs)
            return data

    def component_post_dimension_with_http_info(self, id, component_dimension_representation, **kwargs):
        """
        Create dimension of given component id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_post_dimension_with_http_info(id, component_dimension_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component id (required)
        :param Assetic3IntegrationRepresentationsComponentDimensionRepresentation component_dimension_representation: Component Dimension Representation (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'component_dimension_representation']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method component_post_dimension" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `component_post_dimension`")
        # verify the required parameter 'component_dimension_representation' is set
        if ('component_dimension_representation' not in params) or (params['component_dimension_representation'] is None):
            raise ValueError("Missing the required parameter `component_dimension_representation` when calling `component_post_dimension`")


        collection_formats = {}

        resource_path = '/api/v2/components/{id}/dimensions'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'component_dimension_representation' in params:
            body_params = params['component_dimension_representation']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def component_put(self, id, component_representation, **kwargs):
        """
        Update Component
        <strong>Note:</strong>  <ul>    <li>Component Type cannot be changed</li>    <li>Dimension Unit has to be in <strong>Singular form</strong>, such as Metre, Mile, Gallon (US), Kilovolt Ampere, Kilometre Per Hour, Celsius, etc..</li>  </ul>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_put(id, component_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component Id (required)
        :param Assetic3IntegrationRepresentationsComponentRepresentation component_representation: Component Representation (required)
        :return: Assetic3IntegrationRepresentationsComponentRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.component_put_with_http_info(id, component_representation, **kwargs)
        else:
            (data) = self.component_put_with_http_info(id, component_representation, **kwargs)
            return data

    def component_put_with_http_info(self, id, component_representation, **kwargs):
        """
        Update Component
        <strong>Note:</strong>  <ul>    <li>Component Type cannot be changed</li>    <li>Dimension Unit has to be in <strong>Singular form</strong>, such as Metre, Mile, Gallon (US), Kilovolt Ampere, Kilometre Per Hour, Celsius, etc..</li>  </ul>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_put_with_http_info(id, component_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component Id (required)
        :param Assetic3IntegrationRepresentationsComponentRepresentation component_representation: Component Representation (required)
        :return: Assetic3IntegrationRepresentationsComponentRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'component_representation']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method component_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `component_put`")
        # verify the required parameter 'component_representation' is set
        if ('component_representation' not in params) or (params['component_representation'] is None):
            raise ValueError("Missing the required parameter `component_representation` when calling `component_put`")


        collection_formats = {}

        resource_path = '/api/v2/components/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'component_representation' in params:
            body_params = params['component_representation']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsComponentRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def component_put_dimension(self, id, dimension_id, component_dimension_representation, **kwargs):
        """
        Update dimension of given component id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_put_dimension(id, dimension_id, component_dimension_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component Id (required)
        :param str dimension_id: Dimension Id (required)
        :param Assetic3IntegrationRepresentationsComponentDimensionRepresentation component_dimension_representation: Component Dimension Representation (required)
        :return: Assetic3IntegrationRepresentationsComponentDimensionRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.component_put_dimension_with_http_info(id, dimension_id, component_dimension_representation, **kwargs)
        else:
            (data) = self.component_put_dimension_with_http_info(id, dimension_id, component_dimension_representation, **kwargs)
            return data

    def component_put_dimension_with_http_info(self, id, dimension_id, component_dimension_representation, **kwargs):
        """
        Update dimension of given component id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.component_put_dimension_with_http_info(id, dimension_id, component_dimension_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Component Id (required)
        :param str dimension_id: Dimension Id (required)
        :param Assetic3IntegrationRepresentationsComponentDimensionRepresentation component_dimension_representation: Component Dimension Representation (required)
        :return: Assetic3IntegrationRepresentationsComponentDimensionRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'dimension_id', 'component_dimension_representation']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method component_put_dimension" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `component_put_dimension`")
        # verify the required parameter 'dimension_id' is set
        if ('dimension_id' not in params) or (params['dimension_id'] is None):
            raise ValueError("Missing the required parameter `dimension_id` when calling `component_put_dimension`")
        # verify the required parameter 'component_dimension_representation' is set
        if ('component_dimension_representation' not in params) or (params['component_dimension_representation'] is None):
            raise ValueError("Missing the required parameter `component_dimension_representation` when calling `component_put_dimension`")


        collection_formats = {}

        resource_path = '/api/v2/components/{id}/dimensions/{dimensionId}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']
        if 'dimension_id' in params:
            path_params['dimensionId'] = params['dimension_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'component_dimension_representation' in params:
            body_params = params['component_dimension_representation']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsComponentDimensionRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
