# coding: utf-8

"""
    Assetic Integration API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class WorkOrderApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def work_order_get(self, **kwargs):
        """
        Gets work orders based on request parameters
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str assigned_id: Filter WO on the basis of task assigned to a particular resource
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkOrderListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_with_http_info(**kwargs)
        else:
            (data) = self.work_order_get_with_http_info(**kwargs)
            return data

    def work_order_get_with_http_info(self, **kwargs):
        """
        Gets work orders based on request parameters
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str assigned_id: Filter WO on the basis of task assigned to a particular resource
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkOrderListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['assigned_id', 'request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get" % key
                )
            params[key] = val
        del params['kwargs']


        collection_formats = {}

        resource_path = '/api/v2/workorder'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'assigned_id' in params:
            query_params['assignedId'] = params['assigned_id']
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsWorkOrderListRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_get_0(self, id, **kwargs):
        """
        Get specific work order by providing Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_0(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The ID of the value you want to return (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_0_with_http_info(id, **kwargs)
        else:
            (data) = self.work_order_get_0_with_http_info(id, **kwargs)
            return data

    def work_order_get_0_with_http_info(self, id, **kwargs):
        """
        Get specific work order by providing Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_0_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The ID of the value you want to return (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get_0" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_get_0`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_get_interruption_by_work_order_id(self, id, **kwargs):
        """
        GET Complex Asset Interruption by Work order Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_interruption_by_work_order_id(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsInterruptionListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_interruption_by_work_order_id_with_http_info(id, **kwargs)
        else:
            (data) = self.work_order_get_interruption_by_work_order_id_with_http_info(id, **kwargs)
            return data

    def work_order_get_interruption_by_work_order_id_with_http_info(self, id, **kwargs):
        """
        GET Complex Asset Interruption by Work order Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_interruption_by_work_order_id_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsInterruptionListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get_interruption_by_work_order_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_get_interruption_by_work_order_id`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/interruption'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsInterruptionListRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_get_interruption_by_work_order_id_0(self, id, interruption_id, **kwargs):
        """
        Get CA down time by Work order Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_interruption_by_work_order_id_0(id, interruption_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param str interruption_id: The CA down time Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_interruption_by_work_order_id_0_with_http_info(id, interruption_id, **kwargs)
        else:
            (data) = self.work_order_get_interruption_by_work_order_id_0_with_http_info(id, interruption_id, **kwargs)
            return data

    def work_order_get_interruption_by_work_order_id_0_with_http_info(self, id, interruption_id, **kwargs):
        """
        Get CA down time by Work order Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_interruption_by_work_order_id_0_with_http_info(id, interruption_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param str interruption_id: The CA down time Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'interruption_id', 'request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get_interruption_by_work_order_id_0" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_get_interruption_by_work_order_id_0`")
        # verify the required parameter 'interruption_id' is set
        if ('interruption_id' not in params) or (params['interruption_id'] is None):
            raise ValueError("Missing the required parameter `interruption_id` when calling `work_order_get_interruption_by_work_order_id_0`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/interruption/{interruptionId}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']
        if 'interruption_id' in params:
            path_params['interruptionId'] = params['interruption_id']

        query_params = {}
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_get_interruption_factor(self, **kwargs):
        """
        Get complex asset down time factors
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_interruption_factor(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsInterruptionFactorListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_interruption_factor_with_http_info(**kwargs)
        else:
            (data) = self.work_order_get_interruption_factor_with_http_info(**kwargs)
            return data

    def work_order_get_interruption_factor_with_http_info(self, **kwargs):
        """
        Get complex asset down time factors
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_interruption_factor_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsInterruptionFactorListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get_interruption_factor" % key
                )
            params[key] = val
        del params['kwargs']


        collection_formats = {}

        resource_path = '/api/v2/interruptionfactor'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsInterruptionFactorListRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_get_labour_by_work_order_id(self, id, **kwargs):
        """
        GET crafts by Work order Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_labour_by_work_order_id(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkOrderLabourListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_labour_by_work_order_id_with_http_info(id, **kwargs)
        else:
            (data) = self.work_order_get_labour_by_work_order_id_with_http_info(id, **kwargs)
            return data

    def work_order_get_labour_by_work_order_id_with_http_info(self, id, **kwargs):
        """
        GET crafts by Work order Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_labour_by_work_order_id_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkOrderLabourListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get_labour_by_work_order_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_get_labour_by_work_order_id`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/labour'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsWorkOrderLabourListRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_get_materials_by_work_order_id(self, id, **kwargs):
        """
        GET materials by Work order Id and task Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_materials_by_work_order_id(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkOrderMaterialListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_materials_by_work_order_id_with_http_info(id, **kwargs)
        else:
            (data) = self.work_order_get_materials_by_work_order_id_with_http_info(id, **kwargs)
            return data

    def work_order_get_materials_by_work_order_id_with_http_info(self, id, **kwargs):
        """
        GET materials by Work order Id and task Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_materials_by_work_order_id_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkOrderMaterialListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get_materials_by_work_order_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_get_materials_by_work_order_id`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/materials'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsWorkOrderMaterialListRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_get_work_order_defect_location(self, id, **kwargs):
        """
        Get WO defect location
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_work_order_defect_location(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_work_order_defect_location_with_http_info(id, **kwargs)
        else:
            (data) = self.work_order_get_work_order_defect_location_with_http_info(id, **kwargs)
            return data

    def work_order_get_work_order_defect_location_with_http_info(self, id, **kwargs):
        """
        Get WO defect location
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_work_order_defect_location_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get_work_order_defect_location" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_get_work_order_defect_location`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/spatiallocation'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_get_work_task_by_work_task_id(self, id, work_task_id, **kwargs):
        """
        GET Work task by Work order Id and task Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_work_task_by_work_task_id(id, work_task_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param str work_task_id: The work task Id of the value you want to return (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_work_task_by_work_task_id_with_http_info(id, work_task_id, **kwargs)
        else:
            (data) = self.work_order_get_work_task_by_work_task_id_with_http_info(id, work_task_id, **kwargs)
            return data

    def work_order_get_work_task_by_work_task_id_with_http_info(self, id, work_task_id, **kwargs):
        """
        GET Work task by Work order Id and task Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_work_task_by_work_task_id_with_http_info(id, work_task_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The work order Id of the value you want to return (required)
        :param str work_task_id: The work task Id of the value you want to return (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'work_task_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get_work_task_by_work_task_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_get_work_task_by_work_task_id`")
        # verify the required parameter 'work_task_id' is set
        if ('work_task_id' not in params) or (params['work_task_id'] is None):
            raise ValueError("Missing the required parameter `work_task_id` when calling `work_order_get_work_task_by_work_task_id`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/worktasks/{workTaskId}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']
        if 'work_task_id' in params:
            path_params['workTaskId'] = params['work_task_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_get_work_tasks_by_work_order_id(self, id, **kwargs):
        """
        GET Work tasks by Work order Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_work_tasks_by_work_order_id(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkTaskListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_get_work_tasks_by_work_order_id_with_http_info(id, **kwargs)
        else:
            (data) = self.work_order_get_work_tasks_by_work_order_id_with_http_info(id, **kwargs)
            return data

    def work_order_get_work_tasks_by_work_order_id_with_http_info(self, id, **kwargs):
        """
        GET Work tasks by Work order Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_get_work_tasks_by_work_order_id_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: The Id of the value you want to return (required)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkTaskListRepresentation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_get_work_tasks_by_work_order_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_get_work_tasks_by_work_order_id`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/worktasks'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsWorkTaskListRepresentation',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_post(self, work_order, **kwargs):
        """
        Create new Work Order
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_post(work_order, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Assetic3IntegrationRepresentationsWorkOrder work_order: Work order details to be saved (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_post_with_http_info(work_order, **kwargs)
        else:
            (data) = self.work_order_post_with_http_info(work_order, **kwargs)
            return data

    def work_order_post_with_http_info(self, work_order, **kwargs):
        """
        Create new Work Order
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_post_with_http_info(work_order, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Assetic3IntegrationRepresentationsWorkOrder work_order: Work order details to be saved (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['work_order']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'work_order' is set
        if ('work_order' not in params) or (params['work_order'] is None):
            raise ValueError("Missing the required parameter `work_order` when calling `work_order_post`")


        collection_formats = {}

        resource_path = '/api/v2/workorder'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'work_order' in params:
            body_params = params['work_order']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_post_interruption(self, id, interruption, **kwargs):
        """
        Save CA down time for Work order
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_post_interruption(id, interruption, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param Assetic3IntegrationRepresentationsInterruption interruption: complex asset interruption to be saved (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_post_interruption_with_http_info(id, interruption, **kwargs)
        else:
            (data) = self.work_order_post_interruption_with_http_info(id, interruption, **kwargs)
            return data

    def work_order_post_interruption_with_http_info(self, id, interruption, **kwargs):
        """
        Save CA down time for Work order
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_post_interruption_with_http_info(id, interruption, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param Assetic3IntegrationRepresentationsInterruption interruption: complex asset interruption to be saved (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'interruption']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_post_interruption" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_post_interruption`")
        # verify the required parameter 'interruption' is set
        if ('interruption' not in params) or (params['interruption'] is None):
            raise ValueError("Missing the required parameter `interruption` when calling `work_order_post_interruption`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/interruption'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'interruption' in params:
            body_params = params['interruption']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_post_work_order_defect_location(self, id, work_order_defect_location, **kwargs):
        """
        Post WO defect location
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_post_work_order_defect_location(id, work_order_defect_location, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param Assetic3IntegrationRepresentationsWorkOrderDefectLocation work_order_defect_location: work order defect location to be created (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_post_work_order_defect_location_with_http_info(id, work_order_defect_location, **kwargs)
        else:
            (data) = self.work_order_post_work_order_defect_location_with_http_info(id, work_order_defect_location, **kwargs)
            return data

    def work_order_post_work_order_defect_location_with_http_info(self, id, work_order_defect_location, **kwargs):
        """
        Post WO defect location
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_post_work_order_defect_location_with_http_info(id, work_order_defect_location, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param Assetic3IntegrationRepresentationsWorkOrderDefectLocation work_order_defect_location: work order defect location to be created (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'work_order_defect_location']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_post_work_order_defect_location" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_post_work_order_defect_location`")
        # verify the required parameter 'work_order_defect_location' is set
        if ('work_order_defect_location' not in params) or (params['work_order_defect_location'] is None):
            raise ValueError("Missing the required parameter `work_order_defect_location` when calling `work_order_post_work_order_defect_location`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/spatiallocation'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'work_order_defect_location' in params:
            body_params = params['work_order_defect_location']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_put(self, id, work_order, **kwargs):
        """
        Update work order data for given model values
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_put(id, work_order, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param Assetic3IntegrationRepresentationsWorkOrder work_order: work order model (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_put_with_http_info(id, work_order, **kwargs)
        else:
            (data) = self.work_order_put_with_http_info(id, work_order, **kwargs)
            return data

    def work_order_put_with_http_info(self, id, work_order, **kwargs):
        """
        Update work order data for given model values
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_put_with_http_info(id, work_order, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param Assetic3IntegrationRepresentationsWorkOrder work_order: work order model (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'work_order']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_put`")
        # verify the required parameter 'work_order' is set
        if ('work_order' not in params) or (params['work_order'] is None):
            raise ValueError("Missing the required parameter `work_order` when calling `work_order_put`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'work_order' in params:
            body_params = params['work_order']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_put_0(self, id, work_task_id, work_task, **kwargs):
        """
        Updates the work task's fields : OtherCosts, Description, ExternalCosts, LossOfService, MaterialStatusId
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_put_0(id, work_task_id, work_task, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param str work_task_id: work task identifier (required)
        :param Assetic3IntegrationRepresentationsWorkTask work_task: work order model (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_put_0_with_http_info(id, work_task_id, work_task, **kwargs)
        else:
            (data) = self.work_order_put_0_with_http_info(id, work_task_id, work_task, **kwargs)
            return data

    def work_order_put_0_with_http_info(self, id, work_task_id, work_task, **kwargs):
        """
        Updates the work task's fields : OtherCosts, Description, ExternalCosts, LossOfService, MaterialStatusId
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_put_0_with_http_info(id, work_task_id, work_task, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param str work_task_id: work task identifier (required)
        :param Assetic3IntegrationRepresentationsWorkTask work_task: work order model (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'work_task_id', 'work_task']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_put_0" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_put_0`")
        # verify the required parameter 'work_task_id' is set
        if ('work_task_id' not in params) or (params['work_task_id'] is None):
            raise ValueError("Missing the required parameter `work_task_id` when calling `work_order_put_0`")
        # verify the required parameter 'work_task' is set
        if ('work_task' not in params) or (params['work_task'] is None):
            raise ValueError("Missing the required parameter `work_task` when calling `work_order_put_0`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/worktasks/{workTaskId}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']
        if 'work_task_id' in params:
            path_params['workTaskId'] = params['work_task_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'work_task' in params:
            body_params = params['work_task']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_update_work_order_material(self, id, work_order_material, **kwargs):
        """
        Updates the work order material's fields : Planned Quantity, Actual Quantity
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_update_work_order_material(id, work_order_material, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param Assetic3IntegrationRepresentationsWorkOrderMaterial work_order_material: work order material model (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_update_work_order_material_with_http_info(id, work_order_material, **kwargs)
        else:
            (data) = self.work_order_update_work_order_material_with_http_info(id, work_order_material, **kwargs)
            return data

    def work_order_update_work_order_material_with_http_info(self, id, work_order_material, **kwargs):
        """
        Updates the work order material's fields : Planned Quantity, Actual Quantity
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_update_work_order_material_with_http_info(id, work_order_material, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param Assetic3IntegrationRepresentationsWorkOrderMaterial work_order_material: work order material model (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'work_order_material']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_update_work_order_material" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_update_work_order_material`")
        # verify the required parameter 'work_order_material' is set
        if ('work_order_material' not in params) or (params['work_order_material'] is None):
            raise ValueError("Missing the required parameter `work_order_material` when calling `work_order_update_work_order_material`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/materials'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'work_order_material' in params:
            body_params = params['work_order_material']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_order_update_work_task_on_execute(self, id, work_task_id, work_order_labour, **kwargs):
        """
        Updates the work task crafts's fields for execution: Task Status, Actual Hours, Comments
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_update_work_task_on_execute(id, work_task_id, work_order_labour, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param str work_task_id: work task identifier (required)
        :param Assetic3IntegrationRepresentationsWorkOrderLabour work_order_labour: work order labour model (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_order_update_work_task_on_execute_with_http_info(id, work_task_id, work_order_labour, **kwargs)
        else:
            (data) = self.work_order_update_work_task_on_execute_with_http_info(id, work_task_id, work_order_labour, **kwargs)
            return data

    def work_order_update_work_task_on_execute_with_http_info(self, id, work_task_id, work_order_labour, **kwargs):
        """
        Updates the work task crafts's fields for execution: Task Status, Actual Hours, Comments
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_order_update_work_task_on_execute_with_http_info(id, work_task_id, work_order_labour, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: work order identifier (required)
        :param str work_task_id: work task identifier (required)
        :param Assetic3IntegrationRepresentationsWorkOrderLabour work_order_labour: work order labour model (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'work_task_id', 'work_order_labour']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_order_update_work_task_on_execute" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_order_update_work_task_on_execute`")
        # verify the required parameter 'work_task_id' is set
        if ('work_task_id' not in params) or (params['work_task_id'] is None):
            raise ValueError("Missing the required parameter `work_task_id` when calling `work_order_update_work_task_on_execute`")
        # verify the required parameter 'work_order_labour' is set
        if ('work_order_labour' not in params) or (params['work_order_labour'] is None):
            raise ValueError("Missing the required parameter `work_order_labour` when calling `work_order_update_work_task_on_execute`")


        collection_formats = {}

        resource_path = '/api/v2/workorder/{id}/labour/{workTaskId}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']
        if 'work_task_id' in params:
            path_params['workTaskId'] = params['work_task_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'work_order_labour' in params:
            body_params = params['work_order_labour']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
