# coding: utf-8

"""
    Assetic Integration API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class WorkRequestApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def work_request_add_supporting_information_for_work_request(self, id, supporting_information_representation, **kwargs):
        """
        Add supporting information to work request
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_add_supporting_information_for_work_request(id, supporting_information_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Work Request Guid (required)
        :param Assetic3IntegrationRepresentationsSupportingInformation supporting_information_representation: (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_request_add_supporting_information_for_work_request_with_http_info(id, supporting_information_representation, **kwargs)
        else:
            (data) = self.work_request_add_supporting_information_for_work_request_with_http_info(id, supporting_information_representation, **kwargs)
            return data

    def work_request_add_supporting_information_for_work_request_with_http_info(self, id, supporting_information_representation, **kwargs):
        """
        Add supporting information to work request
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_add_supporting_information_for_work_request_with_http_info(id, supporting_information_representation, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Work Request Guid (required)
        :param Assetic3IntegrationRepresentationsSupportingInformation supporting_information_representation: (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'supporting_information_representation']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_request_add_supporting_information_for_work_request" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_request_add_supporting_information_for_work_request`")
        # verify the required parameter 'supporting_information_representation' is set
        if ('supporting_information_representation' not in params) or (params['supporting_information_representation'] is None):
            raise ValueError("Missing the required parameter `supporting_information_representation` when calling `work_request_add_supporting_information_for_work_request`")


        collection_formats = {}

        resource_path = '/api/v2/workrequest/{id}/supportinginfo'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'supporting_information_representation' in params:
            body_params = params['supporting_information_representation']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_request_get(self, id, **kwargs):
        """
        Get specific work request by providing Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_get(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Work request id (required)
        :return: Assetic3IntegrationRepresentationsWorkRequest
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_request_get_with_http_info(id, **kwargs)
        else:
            (data) = self.work_request_get_with_http_info(id, **kwargs)
            return data

    def work_request_get_with_http_info(self, id, **kwargs):
        """
        Get specific work request by providing Id
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_get_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Work request id (required)
        :return: Assetic3IntegrationRepresentationsWorkRequest
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_request_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_request_get`")


        collection_formats = {}

        resource_path = '/api/v2/workrequest/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsWorkRequest',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_request_get_supporting_information_for_work_request(self, id, **kwargs):
        """
        Get supporting information history as a list by providing work request guid
        Sample request: <br /><pre>               /api/v2/workrequest/592325B7-A10E-E711-80BB-005056947278/supportinginfo                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_get_supporting_information_for_work_request(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Work Request Guid (required)
        :return: list[Assetic3IntegrationRepresentationsSupportingInformation]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_request_get_supporting_information_for_work_request_with_http_info(id, **kwargs)
        else:
            (data) = self.work_request_get_supporting_information_for_work_request_with_http_info(id, **kwargs)
            return data

    def work_request_get_supporting_information_for_work_request_with_http_info(self, id, **kwargs):
        """
        Get supporting information history as a list by providing work request guid
        Sample request: <br /><pre>               /api/v2/workrequest/592325B7-A10E-E711-80BB-005056947278/supportinginfo                  </pre>
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_get_supporting_information_for_work_request_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: Work Request Guid (required)
        :return: list[Assetic3IntegrationRepresentationsSupportingInformation]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_request_get_supporting_information_for_work_request" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `work_request_get_supporting_information_for_work_request`")


        collection_formats = {}

        resource_path = '/api/v2/workrequest/{id}/supportinginfo'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[Assetic3IntegrationRepresentationsSupportingInformation]',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_request_get_work_request_type(self, **kwargs):
        """
        Get specific work request type
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_get_work_request_type(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkRequestTypeList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_request_get_work_request_type_with_http_info(**kwargs)
        else:
            (data) = self.work_request_get_work_request_type_with_http_info(**kwargs)
            return data

    def work_request_get_work_request_type_with_http_info(self, **kwargs):
        """
        Get specific work request type
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_get_work_request_type_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int request_params_page:
        :param int request_params_page_size:
        :param list[str] request_params_sorts:
        :param list[str] request_params_filters:
        :return: Assetic3IntegrationRepresentationsWorkRequestTypeList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_params_page', 'request_params_page_size', 'request_params_sorts', 'request_params_filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_request_get_work_request_type" % key
                )
            params[key] = val
        del params['kwargs']


        collection_formats = {}

        resource_path = '/api/v2/workrequesttype'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'request_params_page' in params:
            query_params['requestParams.page'] = params['request_params_page']
        if 'request_params_page_size' in params:
            query_params['requestParams.pageSize'] = params['request_params_page_size']
        if 'request_params_sorts' in params:
            query_params['requestParams.sorts'] = params['request_params_sorts']
            collection_formats['requestParams.sorts'] = 'multi'
        if 'request_params_filters' in params:
            query_params['requestParams.filters'] = params['request_params_filters']
            collection_formats['requestParams.filters'] = 'multi'

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='Assetic3IntegrationRepresentationsWorkRequestTypeList',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def work_request_post(self, work_request, **kwargs):
        """
        Create new Work Request
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_post(work_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Assetic3IntegrationRepresentationsWorkRequest work_request: Work request details to be saved (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.work_request_post_with_http_info(work_request, **kwargs)
        else:
            (data) = self.work_request_post_with_http_info(work_request, **kwargs)
            return data

    def work_request_post_with_http_info(self, work_request, **kwargs):
        """
        Create new Work Request
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.work_request_post_with_http_info(work_request, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Assetic3IntegrationRepresentationsWorkRequest work_request: Work request details to be saved (required)
        :return: SystemObject
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['work_request']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method work_request_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'work_request' is set
        if ('work_request' not in params) or (params['work_request'] is None):
            raise ValueError("Missing the required parameter `work_request` when calling `work_request_post`")


        collection_formats = {}

        resource_path = '/api/v2/workrequest'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'work_request' in params:
            body_params = params['work_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded', 'application/hal+json', 'application/hal+xml'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='SystemObject',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
